Subject: Re: [PATCH] arm64: contpte: fix set_access_flags() no-op check for SMMU/ATS faults

From: Catalin Marinas <[email-masked]>
Date: Wed, 4 Mar 2026 17:25:10 +0000

On Wed, Mar 04, 2026 at 11:39:49AM -0400, Jason Gunthorpe wrote:
> On Wed, Mar 04, 2026 at 03:01:51PM +0000, Catalin Marinas wrote:
> > Good point. For the AF bit, the hardware is not allowed to cache it in
> > the TLB, so we can't get an AF fault for an unrelated VA nearby.
> 
> The way we have read the spec is there is no restriction on what PTE
> the HW accesses when it encounters a CONT group.

Trying to find some rule in the Arm ARM, it only says that hardware
AF/DBM only happens to a single entry but it is not specific about which
in a contiguous range.

So yeah, it's better not to assume anything. If it helps software, we
could tighten the architecture but I think the benefit is marginal.

-- 
Catalin